﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace howto_open_combo
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        private DateTime LastCloseTime = DateTime.Now;

        // If the Enter key is pressed, drop the list.
        private void cbo_KeyPress(object sender, KeyPressEventArgs e)
        {
            // See if the user pressed Enter.
            if (e.KeyChar == (char)Keys.Enter)
            {
                // See if the list is already dropped.
                ComboBox cbo = sender as ComboBox;
                if (cbo.DroppedDown) return;

                // See if it has been at least 0.1 seconds since
                // the last time we closed a ComboBox.
                TimeSpan time_since_close = DateTime.Now - LastCloseTime;
                if (time_since_close.TotalSeconds < 0.1) return;

                // Drop the list.
                cbo.DroppedDown = true;
                e.Handled = true;
            }
        }

        // Record the time when we closed a ComboBox.
        private void cbo_DropDownClosed(object sender, EventArgs e)
        {
            LastCloseTime = DateTime.Now;
        }
    }
}
